/////////////////////////////////////////////////////////////////////////////////////////
// Jocopod -- Joystick to Control Port Dongle
//            --          --      --   -
//
// (c) 2015-2016, Oliver "lvr" Tscherwitschke
// lvr@bitbang.de
//
// This file is part of the Jocopod Firmware.
//
// The Jocopod Firmware is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// The Jocopod Firmware is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with the Jocopod Firmware. If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////////////////

#ifndef TYPES_H
#define TYPES_H



/////////////////////////////////////////////////////////////////
// Type definitions

typedef struct
{
    int min;
    int mid;
    int max;
} Scale;


typedef struct
{
    Scale joy;
    Scale pot;
    bool invert;
} Axis;

typedef struct
{
    uint8_t  blinkCount;
    uint16_t onTime;
    uint16_t offTime;
    uint16_t pauseTime;    
} BlinkDef;


typedef struct 
{
    float xThresh;
    float xHyst;
    
    float yThresh; 
    float yHyst; 
} ThDef;





enum OperatingMode {
    MODE_NULL = 0,      // (invalid mode)
    MODE_PADDLE,        // simulate paddles
    MODE_JOY_WHEEL,     // simulate joystick (optimized for wheel control)
    MODE_JOY_STICK,     // simulate joystick (universal for joystick and wheel)
    MODE_INVALID        // (invalid mode)
};



enum DigitalAxisState {MID, NEG, POS};

  


#endif

